import json
import setuptools

kwargs = json.loads(
    """
{
    "name": "cdktf-cdktf-provider-vault",
    "version": "7.0.1",
    "description": "Prebuilt vault Provider for Terraform CDK (cdktf)",
    "license": "MPL-2.0",
    "url": "https://github.com/cdktf/cdktf-provider-vault.git",
    "long_description_content_type": "text/markdown",
    "author": "HashiCorp",
    "bdist_wheel": {
        "universal": true
    },
    "project_urls": {
        "Source": "https://github.com/cdktf/cdktf-provider-vault.git"
    },
    "package_dir": {
        "": "src"
    },
    "packages": [
        "cdktf_cdktf_provider_vault",
        "cdktf_cdktf_provider_vault._jsii",
        "cdktf_cdktf_provider_vault.ad_secret_backend",
        "cdktf_cdktf_provider_vault.ad_secret_library",
        "cdktf_cdktf_provider_vault.ad_secret_role",
        "cdktf_cdktf_provider_vault.alicloud_auth_backend_role",
        "cdktf_cdktf_provider_vault.approle_auth_backend_login",
        "cdktf_cdktf_provider_vault.approle_auth_backend_role",
        "cdktf_cdktf_provider_vault.approle_auth_backend_role_secret_id",
        "cdktf_cdktf_provider_vault.audit",
        "cdktf_cdktf_provider_vault.audit_request_header",
        "cdktf_cdktf_provider_vault.auth_backend",
        "cdktf_cdktf_provider_vault.aws_auth_backend_cert",
        "cdktf_cdktf_provider_vault.aws_auth_backend_client",
        "cdktf_cdktf_provider_vault.aws_auth_backend_config_identity",
        "cdktf_cdktf_provider_vault.aws_auth_backend_identity_whitelist",
        "cdktf_cdktf_provider_vault.aws_auth_backend_login",
        "cdktf_cdktf_provider_vault.aws_auth_backend_role",
        "cdktf_cdktf_provider_vault.aws_auth_backend_role_tag",
        "cdktf_cdktf_provider_vault.aws_auth_backend_roletag_blacklist",
        "cdktf_cdktf_provider_vault.aws_auth_backend_sts_role",
        "cdktf_cdktf_provider_vault.aws_secret_backend",
        "cdktf_cdktf_provider_vault.aws_secret_backend_role",
        "cdktf_cdktf_provider_vault.azure_auth_backend_config",
        "cdktf_cdktf_provider_vault.azure_auth_backend_role",
        "cdktf_cdktf_provider_vault.azure_secret_backend",
        "cdktf_cdktf_provider_vault.azure_secret_backend_role",
        "cdktf_cdktf_provider_vault.cert_auth_backend_role",
        "cdktf_cdktf_provider_vault.consul_secret_backend",
        "cdktf_cdktf_provider_vault.consul_secret_backend_role",
        "cdktf_cdktf_provider_vault.data_vault_ad_access_credentials",
        "cdktf_cdktf_provider_vault.data_vault_approle_auth_backend_role_id",
        "cdktf_cdktf_provider_vault.data_vault_auth_backend",
        "cdktf_cdktf_provider_vault.data_vault_aws_access_credentials",
        "cdktf_cdktf_provider_vault.data_vault_azure_access_credentials",
        "cdktf_cdktf_provider_vault.data_vault_gcp_auth_backend_role",
        "cdktf_cdktf_provider_vault.data_vault_generic_secret",
        "cdktf_cdktf_provider_vault.data_vault_identity_entity",
        "cdktf_cdktf_provider_vault.data_vault_identity_group",
        "cdktf_cdktf_provider_vault.data_vault_identity_oidc_client_creds",
        "cdktf_cdktf_provider_vault.data_vault_identity_oidc_openid_config",
        "cdktf_cdktf_provider_vault.data_vault_identity_oidc_public_keys",
        "cdktf_cdktf_provider_vault.data_vault_kubernetes_auth_backend_config",
        "cdktf_cdktf_provider_vault.data_vault_kubernetes_auth_backend_role",
        "cdktf_cdktf_provider_vault.data_vault_kubernetes_service_account_token",
        "cdktf_cdktf_provider_vault.data_vault_kv_secret",
        "cdktf_cdktf_provider_vault.data_vault_kv_secret_subkeys_v2",
        "cdktf_cdktf_provider_vault.data_vault_kv_secret_v2",
        "cdktf_cdktf_provider_vault.data_vault_kv_secrets_list",
        "cdktf_cdktf_provider_vault.data_vault_kv_secrets_list_v2",
        "cdktf_cdktf_provider_vault.data_vault_nomad_access_token",
        "cdktf_cdktf_provider_vault.data_vault_policy_document",
        "cdktf_cdktf_provider_vault.data_vault_raft_autopilot_state",
        "cdktf_cdktf_provider_vault.data_vault_transform_decode",
        "cdktf_cdktf_provider_vault.data_vault_transform_encode",
        "cdktf_cdktf_provider_vault.data_vault_transit_decrypt",
        "cdktf_cdktf_provider_vault.data_vault_transit_encrypt",
        "cdktf_cdktf_provider_vault.database_secret_backend_connection",
        "cdktf_cdktf_provider_vault.database_secret_backend_role",
        "cdktf_cdktf_provider_vault.database_secret_backend_static_role",
        "cdktf_cdktf_provider_vault.database_secrets_mount",
        "cdktf_cdktf_provider_vault.egp_policy",
        "cdktf_cdktf_provider_vault.gcp_auth_backend",
        "cdktf_cdktf_provider_vault.gcp_auth_backend_role",
        "cdktf_cdktf_provider_vault.gcp_secret_backend",
        "cdktf_cdktf_provider_vault.gcp_secret_impersonated_account",
        "cdktf_cdktf_provider_vault.gcp_secret_roleset",
        "cdktf_cdktf_provider_vault.gcp_secret_static_account",
        "cdktf_cdktf_provider_vault.generic_endpoint",
        "cdktf_cdktf_provider_vault.generic_secret",
        "cdktf_cdktf_provider_vault.github_auth_backend",
        "cdktf_cdktf_provider_vault.github_team",
        "cdktf_cdktf_provider_vault.github_user",
        "cdktf_cdktf_provider_vault.identity_entity",
        "cdktf_cdktf_provider_vault.identity_entity_alias",
        "cdktf_cdktf_provider_vault.identity_entity_policies",
        "cdktf_cdktf_provider_vault.identity_group",
        "cdktf_cdktf_provider_vault.identity_group_alias",
        "cdktf_cdktf_provider_vault.identity_group_member_entity_ids",
        "cdktf_cdktf_provider_vault.identity_group_member_group_ids",
        "cdktf_cdktf_provider_vault.identity_group_policies",
        "cdktf_cdktf_provider_vault.identity_mfa_duo",
        "cdktf_cdktf_provider_vault.identity_mfa_login_enforcement",
        "cdktf_cdktf_provider_vault.identity_mfa_okta",
        "cdktf_cdktf_provider_vault.identity_mfa_pingid",
        "cdktf_cdktf_provider_vault.identity_mfa_totp",
        "cdktf_cdktf_provider_vault.identity_oidc",
        "cdktf_cdktf_provider_vault.identity_oidc_assignment",
        "cdktf_cdktf_provider_vault.identity_oidc_client",
        "cdktf_cdktf_provider_vault.identity_oidc_key",
        "cdktf_cdktf_provider_vault.identity_oidc_key_allowed_client_id",
        "cdktf_cdktf_provider_vault.identity_oidc_provider",
        "cdktf_cdktf_provider_vault.identity_oidc_role",
        "cdktf_cdktf_provider_vault.identity_oidc_scope",
        "cdktf_cdktf_provider_vault.jwt_auth_backend",
        "cdktf_cdktf_provider_vault.jwt_auth_backend_role",
        "cdktf_cdktf_provider_vault.kmip_secret_backend",
        "cdktf_cdktf_provider_vault.kmip_secret_role",
        "cdktf_cdktf_provider_vault.kmip_secret_scope",
        "cdktf_cdktf_provider_vault.kubernetes_auth_backend_config",
        "cdktf_cdktf_provider_vault.kubernetes_auth_backend_role",
        "cdktf_cdktf_provider_vault.kubernetes_secret_backend",
        "cdktf_cdktf_provider_vault.kubernetes_secret_backend_role",
        "cdktf_cdktf_provider_vault.kv_secret",
        "cdktf_cdktf_provider_vault.kv_secret_backend_v2",
        "cdktf_cdktf_provider_vault.kv_secret_v2",
        "cdktf_cdktf_provider_vault.ldap_auth_backend",
        "cdktf_cdktf_provider_vault.ldap_auth_backend_group",
        "cdktf_cdktf_provider_vault.ldap_auth_backend_user",
        "cdktf_cdktf_provider_vault.managed_keys",
        "cdktf_cdktf_provider_vault.mfa_duo",
        "cdktf_cdktf_provider_vault.mfa_okta",
        "cdktf_cdktf_provider_vault.mfa_pingid",
        "cdktf_cdktf_provider_vault.mfa_totp",
        "cdktf_cdktf_provider_vault.mongodbatlas_secret_backend",
        "cdktf_cdktf_provider_vault.mongodbatlas_secret_role",
        "cdktf_cdktf_provider_vault.mount",
        "cdktf_cdktf_provider_vault.namespace",
        "cdktf_cdktf_provider_vault.nomad_secret_backend",
        "cdktf_cdktf_provider_vault.nomad_secret_role",
        "cdktf_cdktf_provider_vault.okta_auth_backend",
        "cdktf_cdktf_provider_vault.okta_auth_backend_group",
        "cdktf_cdktf_provider_vault.okta_auth_backend_user",
        "cdktf_cdktf_provider_vault.password_policy",
        "cdktf_cdktf_provider_vault.pki_secret_backend_cert",
        "cdktf_cdktf_provider_vault.pki_secret_backend_config_ca",
        "cdktf_cdktf_provider_vault.pki_secret_backend_config_urls",
        "cdktf_cdktf_provider_vault.pki_secret_backend_crl_config",
        "cdktf_cdktf_provider_vault.pki_secret_backend_intermediate_cert_request",
        "cdktf_cdktf_provider_vault.pki_secret_backend_intermediate_set_signed",
        "cdktf_cdktf_provider_vault.pki_secret_backend_role",
        "cdktf_cdktf_provider_vault.pki_secret_backend_root_cert",
        "cdktf_cdktf_provider_vault.pki_secret_backend_root_sign_intermediate",
        "cdktf_cdktf_provider_vault.pki_secret_backend_sign",
        "cdktf_cdktf_provider_vault.policy",
        "cdktf_cdktf_provider_vault.provider",
        "cdktf_cdktf_provider_vault.quota_lease_count",
        "cdktf_cdktf_provider_vault.quota_rate_limit",
        "cdktf_cdktf_provider_vault.rabbitmq_secret_backend",
        "cdktf_cdktf_provider_vault.rabbitmq_secret_backend_role",
        "cdktf_cdktf_provider_vault.raft_autopilot",
        "cdktf_cdktf_provider_vault.raft_snapshot_agent_config",
        "cdktf_cdktf_provider_vault.rgp_policy",
        "cdktf_cdktf_provider_vault.ssh_secret_backend_ca",
        "cdktf_cdktf_provider_vault.ssh_secret_backend_role",
        "cdktf_cdktf_provider_vault.terraform_cloud_secret_backend",
        "cdktf_cdktf_provider_vault.terraform_cloud_secret_creds",
        "cdktf_cdktf_provider_vault.terraform_cloud_secret_role",
        "cdktf_cdktf_provider_vault.token",
        "cdktf_cdktf_provider_vault.token_auth_backend_role",
        "cdktf_cdktf_provider_vault.transform_alphabet",
        "cdktf_cdktf_provider_vault.transform_role",
        "cdktf_cdktf_provider_vault.transform_template",
        "cdktf_cdktf_provider_vault.transform_transformation",
        "cdktf_cdktf_provider_vault.transit_secret_backend_key",
        "cdktf_cdktf_provider_vault.transit_secret_cache_config"
    ],
    "package_data": {
        "cdktf_cdktf_provider_vault._jsii": [
            "provider-vault@7.0.1.jsii.tgz"
        ],
        "cdktf_cdktf_provider_vault": [
            "py.typed"
        ]
    },
    "python_requires": "~=3.7",
    "install_requires": [
        "cdktf>=0.16.0, <0.17.0",
        "constructs>=10.0.0, <11.0.0",
        "jsii>=1.80.0, <2.0.0",
        "publication>=0.0.3",
        "typeguard~=2.13.3"
    ],
    "classifiers": [
        "Intended Audience :: Developers",
        "Operating System :: OS Independent",
        "Programming Language :: JavaScript",
        "Programming Language :: Python :: 3 :: Only",
        "Programming Language :: Python :: 3.7",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Typing :: Typed",
        "Development Status :: 5 - Production/Stable",
        "License :: OSI Approved"
    ],
    "scripts": []
}
"""
)

with open("README.md", encoding="utf8") as fp:
    kwargs["long_description"] = fp.read()


setuptools.setup(**kwargs)
